## c4core 0.2.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
project(c4core
    DESCRIPTION "Multiplatform low-level C++ utilities"
    HOMEPAGE_URL "https://github.com/biojppm/c4core"
    LANGUAGES CXX)
include(./cmake/c4Project.cmake)
include(./compat.cmake)

c4_project(VERSION 0.2.6
    AUTHOR "Joao Paulo Magalhaes <dev@jpmag.me>")

option(C4CORE_INSTALL "create install target" ON)
option(C4CORE_WITH_FASTFLOAT "use fastfloat to parse floats" ON)
option(C4CORE_NO_DEBUG_BREAK "disable use of debug break even in debug builds" OFF)

set(C4CORE_SRC_FILES
    c4/allocator.hpp
    c4/base64.hpp
    c4/base64.cpp
    c4/blob.hpp
    c4/bitmask.hpp
    c4/charconv.hpp
    c4/c4_pop.hpp
    c4/c4_push.hpp
    c4/char_traits.cpp
    c4/char_traits.hpp
    c4/common.hpp
    c4/compiler.hpp
    c4/config.hpp
    c4/cpu.hpp
    c4/ctor_dtor.hpp
    c4/dump.hpp
    c4/enum.hpp
    c4/error.cpp
    c4/error.hpp
    c4/export.hpp
    c4/format.hpp
    c4/format.cpp
    c4/gcc-4.8.hpp
    c4/hash.hpp
    c4/language.hpp
    c4/language.cpp
    c4/memory_resource.cpp
    c4/memory_resource.hpp
    c4/memory_util.cpp
    c4/memory_util.hpp
    c4/platform.hpp
    c4/preprocessor.hpp
    c4/restrict.hpp
    c4/span.hpp
    c4/std/std.hpp
    c4/std/std_fwd.hpp
    c4/std/string.hpp
    c4/std/string_fwd.hpp
    c4/std/string_view.hpp
    c4/std/tuple.hpp
    c4/std/vector.hpp
    c4/std/vector_fwd.hpp
    c4/substr.hpp
    c4/substr_fwd.hpp
    c4/szconv.hpp
    c4/type_name.hpp
    c4/types.hpp
    c4/unrestrict.hpp
    c4/utf.hpp
    c4/utf.cpp
    c4/windows.hpp
    c4/version.hpp
    c4/version.cpp
    c4/windows_pop.hpp
    c4/windows_push.hpp
    c4/c4core.natvis
    #
    c4/ext/debugbreak/debugbreak.h
    c4/ext/rng/rng.hpp
    c4/ext/sg14/inplace_function.h
    )
if(C4CORE_WITH_FASTFLOAT)
    list(APPEND C4CORE_SRC_FILES
        c4/ext/fast_float.hpp
        c4/ext/fast_float_all.h
        )
endif()
set(C4CORE_AMALGAMATED ${C4CORE_SRC_DIR}/../src_singleheader/c4/c4core_all.hpp)
list(TRANSFORM C4CORE_SRC_FILES PREPEND "${C4CORE_SRC_DIR}/" OUTPUT_VARIABLE C4CORE_SRC_FILES_FULL)

add_custom_target(c4core-amalgamate
    python ${CMAKE_CURRENT_LIST_DIR}/tools/amalgamate.py ${C4CORE_AMALGAMATED}
    COMMENT "${CMAKE_CURRENT_LIST_DIR}/tools/amalgamate.py ${C4CORE_AMALGAMATED}"
    BYPRODUCTS ${C4CORE_AMALGAMATED}
    DEPENDS ${C4CORE_SRC_FILES_FULL}
    )

c4_add_library(c4core
    INC_DIRS
       $<BUILD_INTERFACE:${C4CORE_SRC_DIR}> $<INSTALL_INTERFACE:include>
    SOURCE_ROOT ${C4CORE_SRC_DIR}
    SOURCES ${C4CORE_SRC_FILES}
)
if(NOT C4CORE_WITH_FASTFLOAT)
    target_compile_definitions(c4core PUBLIC -DC4CORE_NO_FAST_FLOAT)
endif()
if(C4CORE_NO_DEBUG_BREAK)
    target_compile_definitions(c4core PUBLIC -DC4_NO_DEBUG_BREAK)
endif()


#-------------------------------------------------------

if(C4CORE_INSTALL)
    c4_install_target(c4core)
    c4_install_exports()
endif()

c4_add_dev_targets()

if(C4CORE_INSTALL)
    c4_pack_project(TYPE LIBRARY)
endif()


#-------------------------------------------------------
# clang-tidy

function(c4core_setup_clang_tidy rootdir)
    get_target_property(srcs c4core SOURCES)
    string(REPLACE "${rootdir}/" "./" srcs "${srcs}")
    set(exclude ./c4/ext/.* .natvis)
    foreach(e ${exclude})
        list(FILTER srcs EXCLUDE REGEX ${e})
    endforeach()
    set(cmd ${srcs} -p ${CMAKE_BINARY_DIR}
            "--config-file=${rootdir}/.clang-tidy"
            "--header-filter=${rootdir}/src/c4/.*pp|${rootdir}/src/c4/std/.*pp")
    add_custom_target(c4core-clang-tidy
        COMMAND ${CMAKE_COMMAND} -E cat ${CMAKE_BINARY_DIR}/compile_commands.json
        COMMAND ${CLANG_TIDY} --version
        COMMAND ${CLANG_TIDY} ${cmd} --dump-config
        COMMAND ${CLANG_TIDY} ${cmd} --list-checks
        COMMAND ${CLANG_TIDY} ${cmd}
        WORKING_DIRECTORY ${rootdir}
        VERBATIM
    )
endfunction()

find_program(CLANG_TIDY clang-tidy)
if(CLANG_TIDY)
    c4core_setup_clang_tidy(${CMAKE_CURRENT_LIST_DIR})
endif()

=== debian/changelog ===
c4core (0.2.6-2) unstable; urgency=medium

  * Let libc4core-dev depend on debugbreak.

 -- Bastian Germann <bage@debian.org>  Tue, 06 May 2025 22:33:12 +0200

c4core (0.2.6-1) unstable; urgency=medium

  * Initial release. Closes: #1017088

 -- Bastian Germann <bage@debian.org>  Thu, 01 May 2025 07:31:06 +0000

=== debian/control ===
Source: c4core
Section: libs
Priority: optional
Maintainer: Bastian Germann <bage@debian.org>
Build-Depends: cmake, debhelper-compat (= 13), debugbreak
Standards-Version: 4.6.2
Homepage: https://github.com/biojppm/c4core
Rules-Requires-Root: no

Package: libc4core0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: low-latency, low-level C++ library
 c4core is a library of low-level C++ utilities,
 written with low-latency projects in mind.
 .
 Some of the utilities provided by c4core have already
 equivalent functionality in the C++ standard, but they are
 provided as the existing C++ equivalent may be insufficient
 (eg, std::string_view), inefficient (eg, std::string),
 heavy (eg streams), or plainly unusable on some platforms/projects,
 (eg exceptions).
 .
 Some other utilities have equivalent under consideration for C++
 standardisation; and yet some other utilities have no equivalent
 under consideration.

Package: libc4core-dev
Architecture: any
Depends: ${misc:Depends}, libc4core0 (= ${binary:Version}), debugbreak
Section: libdevel
Description: low-latency, low-level C++ library (development files)
 c4core is a library of low-level C++ utilities,
 written with low-latency projects in mind.
 .
 Some of the utilities provided by c4core have already
 equivalent functionality in the C++ standard, but they are
 provided as the existing C++ equivalent may be insufficient
 (eg, std::string_view), inefficient (eg, std::string),
 heavy (eg streams), or plainly unusable on some platforms/projects,
 (eg exceptions).
 .
 Some other utilities have equivalent under consideration for C++
 standardisation; and yet some other utilities have no equivalent
 under consideration.
 .
 This package holds the header and development library link.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	      -DC4CORE_WITH_FASTFLOAT=OFF -DBUILD_SHARED_LIBS=SHARED

## c4core 0.2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 include(./cmake/c4Project.cmake)
 include(./compat.cmake)
 
-c4_project(VERSION 0.2.6
+c4_project(VERSION 0.2.7
     AUTHOR "Joao Paulo Magalhaes <dev@jpmag.me>")
 
 option(C4CORE_INSTALL "create install target" ON)

=== bm-xp/requirements.txt ===
munch
pyyaml
py-cpuinfo
psutil
gitpython
flask
markupsafe
Frozen-Flask
requests
mmh3
numpy==1.23.1
bokeh<3.0
selenium
matplotlib
prettytable

=== bm/CMakeLists.txt ===
c4_setup_benchmarking()

add_custom_target(c4core-bm-plot)
c4_set_folder_remote_project_targets(bm/plot c4core-bm-plot)
find_package(Python REQUIRED COMPONENTS Interpreter)

#----------------------------------------------

c4_add_executable(c4core-bm-format
    SOURCES bm_format.cpp
    LIBS c4core benchmark
    FOLDER bm)

c4_add_target_benchmark(c4core-bm-format cat FILTER "^cat_.*")
c4_add_target_benchmark(c4core-bm-format catsep FILTER "^catsep_.*")
c4_add_target_benchmark(c4core-bm-format format FILTER "^format_.*")

c4_add_target_benchmark(c4core-bm-format catfile FILTER "^catfile_.*")
c4_add_target_benchmark(c4core-bm-format catsepfile FILTER "^catsepfile_.*")
c4_add_target_benchmark(c4core-bm-format formatfile FILTER "^formatfile_.*")


#----------------------------------------------

# R&D for xtoa
option(C4CORE_BM_XTOA_RND "whether to enable R&D benchmark for xtoa" OFF)
option(C4CORE_BM_ATOX_RND "whether to enable R&D benchmark for atox" OFF)

if(C4CORE_BM_XTOA_RND)
    c4_add_executable(c4core-bm-xtoa
        SOURCES bm_xtoa.cpp
        LIBS c4core benchmark
        FOLDER bm)

    function(c4core_xtoa_benchmark pfx)
        foreach(case ${ARGN})
            c4_add_target_benchmark(c4core-bm-xtoa ${pfx}-${case} FILTER "^${pfx}_.*<${case}.*")
        endforeach()
    endfunction()

    c4core_xtoa_benchmark(msb uint8 int8 uint16 int16 uint32 int32 uint64 int64)
    c4core_xtoa_benchmark(digits_dec uint8 int8 uint16 int16 uint32 int32 uint64 int64)
    c4core_xtoa_benchmark(write_dec uint8 int8 uint16 int16 uint32 int32 uint64 int64)
endif()

if(C4CORE_BM_ATOX_RND)
    c4_add_executable(c4core-bm-atox
        SOURCES bm_atox.cpp
        LIBS c4core benchmark
        FOLDER bm)
    function(c4core_atox_benchmark)
        foreach(case ${ARGN})
            c4_add_target_benchmark(c4core-bm-atox ${case} FILTER "^.*<${case}.*")
        endforeach()
    endfunction()
    c4core_atox_benchmark(uint8 int8 uint16 int16 uint32 int32 uint64 int64)
endif()


#----------------------------------------------

c4_add_executable(c4core-bm-charconv
    SOURCES bm_charconv.cpp bm_charconv.hpp
    LIBS c4core benchmark
    INC_DIRS ${C4CORE_SRC_DIR}/c4/ext/fast_float/include
    FOLDER bm)

# libraries to compare. defaults to off.
option(C4CORE_BM_USE_RYU "enable comparison with ryu library" OFF)
option(C4CORE_BM_USE_FP "enable comparison with fp library" OFF)

# fp requires c++17 or later
get_property(known_features GLOBAL PROPERTY CMAKE_CXX_KNOWN_FEATURES)
if(cxx_std_17 IN_LIST known_features)
    set(C4CORE_BM_USE_FP OFF CACHE BOOL "" FORCE)
endif()
if(C4CORE_BM_USE_FP)
    c4_require_subproject(fp
        REMOTE
            GIT_REPOSITORY https://github.com/jk-jeon/fp
            GIT_TAG master GIT_SHALLOW ON
        EXCLUDE_FROM_ALL)
    target_link_libraries(c4core-bm-charconv PRIVATE jkj_fp)
    target_compile_definitions(c4core-bm-charconv PUBLIC -DC4CORE_BM_USE_FP)
endif()

# ryu not supported in windows with 32bit
if(MSVC AND (CMAKE_SIZEOF_VOID_P EQUAL 4))
    set(C4CORE_BM_USE_RYU OFF CACHE BOOL "" FORCE)
endif()
if(C4CORE_BM_USE_RYU)
    # ryu requires too much code; use an include for clarity
    include(./ryu.cmake)
    target_link_libraries(c4core-bm-charconv PRIVATE ryu_c4)
    target_compile_definitions(c4core-bm-charconv PUBLIC -DC4CORE_BM_USE_RYU)
endif()


function(c4core_charconv_benchmark name rx)
    unset(result_files)
    foreach(datatype ${ARGN})
        c4_add_target_benchmark(c4core-bm-charconv ${name}-${datatype} FILTER "${rx}<${datatype}.*"
            RESULTS_FILE results_file)
        list(APPEND result_files ${results_file})
    endforeach()
    add_custom_target(c4core-bm-charconv-${name}-plot
        #DEPENDS ${result_files}
        COMMAND cmake -E echo "${Python_EXECUTABLE}"
        COMMAND ${Python_EXECUTABLE} --version
        COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/bm_plot_c4core.py ${name} ${result_files}
        )
    add_dependencies(c4core-bm-plot c4core-bm-charconv-${name}-plot)
    c4_set_folder_remote_project_targets(bm/plot c4core-bm-charconv-${name}-plot)
endfunction()

c4core_charconv_benchmark(digits "^c4_digits.*"  uint8 int8 uint16 int16 uint32 int32 uint64 int64)
c4core_charconv_benchmark(xtoa   "^xtoa_.*"      uint8 int8 uint16 int16 uint32 int32 uint64 int64)
c4core_charconv_benchmark(atox   "^atox_.*"      uint8 int8 uint16 int16 uint32 int32 uint64 int64)
c4core_charconv_benchmark(ftoa   "^xtoa_.*"      float double)
c4core_charconv_benchmark(atof   "^atox_.*"      float double)


#----------------------------------------------

option(C4CORE_BM_FLOAT_CMP "compare between alternative implementations for reading/writing floats" ON)
if(C4CORE_BM_FLOAT_CMP)
    add_subdirectory(float)
endif()


#----------------------------------------------


option(C4CORE_BM_ITOA_THREADS "compare itoa thread degradation across alternative implementations" OFF)
if(C4CORE_BM_ITOA_THREADS)
    c4_download_remote_proj(stb stbdir REMOTE
        GIT_REPOSITORY https://github.com/nothings/stb GIT_SHALLOW ON)

    c4_require_subproject(fmtlib REMOTE
        GIT_REPOSITORY https://github.com/fmtlib/fmt
        GIT_TAG 8.1.1
        GIT_SHALLOW ON)
    c4_set_folder_remote_project_targets(ext fmt)

    c4_add_executable(c4core-bm-itoa_threads
        SOURCES bm_itoa_threads.cpp bm_charconv.hpp
        LIBS fmt c4core benchmark
        INC_DIRS ${stbdir}
        FOLDER bm)

    unset(_c4core_itoa_thread_result_files)
    add_custom_target(c4core-bm-itoa_threads-all)
    function(c4core_itoa_threads_benchmark name rx)
        set(li ${_c4core_itoa_thread_result_files})
        c4_add_target_benchmark(c4core-bm-itoa_threads ${name} FILTER "${rx}"
            RESULTS_FILE results_file)
        add_dependencies(c4core-bm-itoa_threads-all c4core-bm-itoa_threads-${name})
        c4_set_folder_remote_project_targets(bm/run c4core-bm-itoa_threads-all)
        list(APPEND li ${results_file})
        set(_c4core_itoa_thread_result_files ${li} PARENT_SCOPE)
    endfunction()

    c4core_itoa_threads_benchmark(c4_write_dec "^c4_write_dec/.*")
    c4core_itoa_threads_benchmark(c4_itoa "^c4_itoa/.*")
    c4core_itoa_threads_benchmark(c4_xtoa "^c4_xtoa/.*")
    c4core_itoa_threads_benchmark(c4_to_chars "^c4_to_chars/.*")
    c4core_itoa_threads_benchmark(std_to_chars "^std_to_chars/.*")
    c4core_itoa_threads_benchmark(fmtlib_format_to "^fmtlib_format_to/.*")
    c4core_itoa_threads_benchmark(snprintf "^snprintf/.*")
    c4core_itoa_threads_benchmark(stb_snprintf "^stb_snprintf/.*")
    if(WIN32)
    c4core_itoa_threads_benchmark(snprintf_l "^snprintf_l/.*")
    c4core_itoa_threads_benchmark(itoa "^itoa/.*")
    #get_property(known_features GLOBAL PROPERTY CMAKE_CXX_KNOWN_FEATURES)
    #if(cxx_std_20 IN_LIST known_features)
    #c4core_itoa_threads_benchmark(std_format_to "^std_format_to/.*")
    #endif()
    endif()
    c4core_itoa_threads_benchmark(sstream "^sstream/.*")
    c4core_itoa_threads_benchmark(sstream_naive_reuse "^sstream_naive_reuse/.*")
    c4core_itoa_threads_benchmark(sstream_naive "^sstream_naive/.*")
    add_custom_target(c4core-bm-itoa_threads-plot
        #DEPENDS ${_c4core_itoa_thread_result_files}
        COMMAND cmake -E echo "${Python_EXECUTABLE}"
        COMMAND ${Python_EXECUTABLE} --version
        COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/bm_plot_c4core.py itoa_threads ${_c4core_itoa_thread_result_files}
        )
    c4_set_folder_remote_project_targets(bm/plot c4core-bm-itoa_threads-plot)
    add_dependencies(c4core-bm-plot c4core-bm-itoa_threads-plot)
endif()

=== test/CMakeLists.txt ===
if(NOT (CMAKE_VERSION VERSION_LESS "4.0.0"))
    c4_log(STATUS "setting CMAKE_POLICY_VERSION_MINIMUM=3.5 to build doctest")
    set(CMAKE_POLICY_VERSION_MINIMUM 3.5 CACHE STRING "" FORCE)
endif()
c4_setup_testing(DOCTEST)

c4_add_library(c4core-_libtest LIBRARY_TYPE STATIC
    SOURCES
        c4/test.hpp
        c4/main.cpp
        c4/libtest/test.cpp
        c4/libtest/archetypes.cpp
        c4/libtest/archetypes.hpp
        c4/libtest/supprwarn_push.hpp
        c4/libtest/supprwarn_pop.hpp
    LIBS c4core doctest
    DEFS
        # doctest does not deal well with template operator<< for substr
        # see https://github.com/onqtam/doctest/pull/431
        -DC4_SUBSTR_NO_OSTREAM_LSHIFT
    INC_DIRS ${CMAKE_CURRENT_LIST_DIR}
    FOLDER test
    )
if(C4CORE_DEFINED_FROM_SINGLEHEADER)
    target_compile_definitions(c4core-_libtest PUBLIC -DC4CORE_SINGLE_HEADER)
endif()

function(c4core_test name)
    c4_add_executable(c4core-test-${name}
        SOURCES ${ARGN}
        INC_DIRS ${CMAKE_CURRENT_LIST_DIR}
        LIBS c4core-_libtest
        FOLDER test)
    c4_add_test(c4core-test-${name} ARGS --duration=on --no-version=on)
endfunction()

c4core_test(version          test_version.cpp)
c4core_test(preprocessor     test_preprocessor.cpp)
c4core_test(type_name        test_type_name.cpp)
c4core_test(types            test_types.cpp)
c4core_test(szconv           test_szconv.cpp)
c4core_test(error            test_error.cpp)
c4core_test(error_exception  test_error_exception.cpp)
c4core_test(blob             test_blob.cpp)
c4core_test(memory_util      test_memory_util.cpp)
c4core_test(memory_resource  test_memory_resource.cpp)
c4core_test(allocator        test_allocator.cpp)
c4core_test(ctor_dtor        test_ctor_dtor.cpp)
c4core_test(chartraits       test_char_traits.cpp)
c4core_test(enum             test_enum.cpp)
c4core_test(bitmask          test_bitmask.cpp)
c4core_test(span             test_span.cpp)
c4core_test(substr           test_substr.cpp)
c4core_test(charconv         test_charconv.cpp test_numbers.hpp)
c4core_test(utf              test_utf.cpp)
c4core_test(format           test_format.cpp)
c4core_test(dump             test_dump.cpp)
c4core_test(base64           test_base64.cpp)
c4core_test(std_string       test_std_string.cpp)
c4core_test(std_vector       test_std_vector.cpp)

=== .github/workflows-in/Makefile ===
SHELL := bash

YS_VERSION := 0.1.88
YS_PREFIX := /tmp/rapidyaml
YS := $(YS_PREFIX)/bin/ys-$(YS_VERSION)

INPUT_FILES := $(wildcard */*)
SOURCE_FILES := $(wildcard *.ys)
TARGET_FILES := $(SOURCE_FILES:%.ys=../workflows/%.yml)

export PATH := $(YS_PREFIX)/bin:$(PATH)
export YSPATH := $(shell pwd -P)/ys


build: $(TARGET_FILES)


test: force build
	@git diff --exit-code $(TARGET_FILES) && \
	  echo -e '\nPASS - No normative changes to .github/workflows/*.yml'


DIFF_ORIG_COMMIT ?= HEAD
diff:
	set -xe ; for s in $(SOURCE_FILES); do \
	  s=$${s##*/}; \
	  t=$${s%.ys}.yml; \
	  [[ $$(git show $(DIFF_ORIG_COMMIT):.github/workflows/$$t \
	          2>/dev/null) ]] && t=$$t; \
	  diff -u --color=auto \
	    <(yq -P 'sort_keys(..)' \
	         -o=props <(git show $(DIFF_ORIG_COMMIT):.github/workflows/$$t) | \
		 grep -Ev '(^$$|^#)' \
	     ) \
	    <(yq -P 'sort_keys(..)' \
	         -o=props ../workflows-in/$$s | \
		 grep -Ev '(^$$|^#)'\
	     ); \
	  done


force:
	touch *.ys


../workflows/%.yml: %.ys $(YS) $(INPUT_FILES)
	@if [ -f "$@" ] ; then chmod a+w $@ ; fi
	@echo "# DO NOT EDIT - GENERATED FROM .github/workflows-in/$<" > $@
	@echo >> $@
	$(YS) -Y $< >> $@
	@chmod a-w $@
	@wc -lm --total=never $< $@


# Auto install a specific version of ys
install-ys: $(YS)
$(YS):
	curl -s https://yamlscript.org/install | \
	  BIN=1 VERSION=$(YS_VERSION) PREFIX=$(YS_PREFIX) bash


stats:
	@echo "ys : $$(wc -lm *.ys)"
	@echo "yml: $$(wc -lm *.yml)"

=== test/test_install/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)
project(c4core
    DESCRIPTION "Test project for an installed c4core"
    HOMEPAGE_URL "https://github.com/biojppm/c4core"
    LANGUAGES CXX)
include(../../cmake/c4Project.cmake)
c4_project(VERSION 0.2.7
    AUTHOR "Joao Paulo Magalhaes <dev@jpmag.me>")

if(C4CORE_TEST_INSTALL_PACKAGE_MODE)
    find_package(c4core REQUIRED)
    add_library(c4core ALIAS c4core::c4core)
else()
    find_path(SUBSTR_HPP substr.hpp PATH_SUFFIXES c4 REQUIRED)
    find_library(C4CORE_LIBRARY c4core REQUIRED)
    get_filename_component(C4CORE_INCLUDE_DIR "${SUBSTR_HPP}" DIRECTORY)
    add_library(c4core UNKNOWN IMPORTED)
    set_target_properties(c4core PROPERTIES IMPORTED_LOCATION "${C4CORE_LIBRARY}")
    target_include_directories(c4core INTERFACE "${C4CORE_INCLUDE_DIR}")
endif()

enable_testing()
set(C4CORE_INSTALL_TEST ON)
add_subdirectory(../../test test)

=== test/test_singleheader/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
project(c4core
    DESCRIPTION "Single header version of c4core library for testing"
    HOMEPAGE_URL "https://github.com/biojppm/c4core"
    LANGUAGES CXX)
include(../../cmake/c4Project.cmake)
c4_project(VERSION 0.2.7
    AUTHOR "Joao Paulo Magalhaes <dev@jpmag.me>")

# amalgamate c4core to get the single header
function(amalgamate_c4core header_dir header_file)
    set(c4coredir "${CMAKE_CURRENT_LIST_DIR}/../..")
    set(singleheaderdir "${c4coredir}/src_singleheader")
    set(singleheader "${singleheaderdir}/c4/c4core_all.hpp")
    set(amscript "${c4coredir}/tools/amalgamate.py")
    file(GLOB_RECURSE srcfiles
        LIST_DIRECTORIES FALSE
        CONFIGURE_DEPENDS
        "${c4coredir}/src")
    add_custom_command(OUTPUT "${singleheader}"
        COMMAND python "${amscript}" "${singleheader}"
        COMMENT "python ${amscript} ${singleheader}"
        DEPENDS ${srcfiles} "${amscript}" "${c4coredir}/cmake/amalgamate_utils.py")
    set(${header_dir} "${singleheaderdir}" PARENT_SCOPE)
    set(${header_file} "${singleheader}" PARENT_SCOPE)
endfunction()
amalgamate_c4core(HEADER_DIR HEADER_FILE)

c4_add_library(c4core
    INC_DIRS
        $<BUILD_INTERFACE:${HEADER_DIR}> $<INSTALL_INTERFACE:include>
    SOURCE_ROOT ${HEADER_DIR}
    SOURCES
        ${HEADER_FILE}
        ${CMAKE_CURRENT_LIST_DIR}/libc4core_singleheader.cpp)
target_compile_definitions(c4core PUBLIC -DC4CORE_SINGLE_HEADER)

enable_testing()
set(C4CORE_DEFINED_FROM_SINGLEHEADER ON)
add_subdirectory(../../test test)

=== debian/changelog ===
c4core (0.2.7-1) unstable; urgency=medium

  * New upstream release
  * Adopt package (Closes: #1104864)
  * Bump Standards-Version to 4.7.2; no changes needed
  * debian/rules: enable hardening flags (hardening=+all)
  * debian/upstream/metadata: created
  * debian/copyright: updated year

 -- Gabriel Barrantes <gabriel.barrantes.dev@outlook.com>  Thu, 02 Oct 2025 22:29:47 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: c4core
 Section: libs
 Priority: optional
-Maintainer: Bastian Germann <bage@debian.org>
+Maintainer: Gabriel Barrantes <gabriel.barrantes.dev@outlook.com>
 Build-Depends: cmake, debhelper-compat (= 13), debugbreak
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/biojppm/c4core
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	      -DC4CORE_WITH_FASTFLOAT=OFF -DBUILD_SHARED_LIBS=SHARED

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%c4core-$1.tar.gz%,repacksuffix=+ds,dversionmangle=s/\+ds\d*$//" \
https://github.com/biojppm/c4core/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

opts="component=cmake,mode=git,pretty=%cd.%h" \
https://github.com/biojppm/cmake.git \
HEAD ignore uupdate
